# include <iostream>
# include <iomanip>
# include <string>
# include <algorithm>
# include <fstream>
# include <cstring>
# include <vector>
# include <set>
# include <queue>
# include <map>
# define PB push_back
# define FF first
# define SS second
using namespace std;
typedef long long LL;
typedef pair<int,int> PII;
const LL DELTA=11287;
const int N=16;
const int MAX_N=70;

string i2s(LL x)
{
	string ret;
	while(x){ret+=char('0'+x%2);x/=2;}
	reverse(ret.begin(),ret.end());
	return ret;
}

LL s2i(string x)
{
	LL ret=0;
	for(int i=0;i<(int)x.size();i++)
		ret=ret*2+(LL)(x[i]-'0');
	return ret;
}

string Cat(vector<string> &V)
{
	string Ret;
	for(int i=0;i<(int)V.size();i++)
			Ret+=V[i];
	return Ret;
}

bool fcmp(const string &a,const string &b){return (a+b<b+a);}

vector<string> V;
LL Fac[MAX_N];

int main()
{
	for(int i=1;i<=N;i++)
		V.PB(i2s(i));
	sort(V.begin(),V.end(),fcmp);
	LL M=s2i(Cat(V));	

	Fac[0]=1;
	for(int i=1;i<MAX_N;i++)
		Fac[i]=(i*Fac[i-1])%DELTA;
	
	LL K=1;
	int prev=0;
	for(int i=1;i<(int)V.size();i++)
	{
		if(V[i]+V[i-1]==V[i-1]+V[i])
			continue;
		K*=Fac[i-prev];
		prev=i;
	}
	K*=Fac[(int)V.size()-prev];
	
	cout<<"M = "<<M<<" K = "<<K<<endl;
	cout<<(K*M)%DELTA<<endl;
	return 0;
}
